/* 
// Project : SD-CARD
// Date    : 25.08.2010
// Author  : XMEGA
// Company : PRIVAT
// Chip type               : ATxmega128A3
// AVR Core Clock frequency: 16,000000 MHz
// Display EADOGM102 
*/
		      	

//	ATXMEGA SPID
  	
//	MMC_Chip_Select 	(Pin30)	   	MMC/SD-Karte (CS)
//	MMC_MOSI    		(Pin31)	  	MMC/SD-Karte (DI)
//	MMC_MISO    		(Pin32)	  	MMC/SD-Karte (DO)
//	MMC_Clock 			(Pin33)	   	MMC/SD-Karte (CLK)

//  PORTB_OUTSET = PIN0_bm;  //zeigt an, alles iO

#include "tools.h"



volatile unsigned char 	TimingDelay;	// fuer mmc.c


int main(void)
{

	
	system_clocks_init(); 	//  Internal 32/2 = 16MHz  RC oscillator intern
 
	

	TCD0.PER=0x61A7; //  100ms fr  SDCARD
	TCD0.CTRLA = ( TCD0.CTRLA & ~TC0_CLKSEL_gm ) | TC_CLKSEL_DIV64_gc;
	TCD0.INTCTRLA = ( TCD0.INTCTRLA & ~TC0_OVFINTLVL_gm ) | RTC_OVFINTLVL_MED_gc;
	TimingDelay = 0;		

	PORTB_DIRSET  = PIN0_bm;  //Messung aktiv
	


	// Enable HI/MED/LO interrupt level
	// Interupt einschalten
	PMIC.CTRL |= PMIC_HILVLEN_bm; 
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	PMIC.CTRL |= PMIC_LOLVLEN_bm;
	
	
	sei(); 

 
	unsigned char file_name [] = "test.txt"; 	
	unsigned char str [] = "Hallo Datei!";
	unsigned long int seek;

	// timer0 config  **************************************************
	// initialisierung, auf jeden fall vor mmc_init(), 
	// denn da wird der timer benoetigt!


	
	// sd/mmc config  **************************************************
	
	if( FALSE == mmc_init() ){
	} 

	//uputs((unsigned char*)"...");
		
	
	// fat config ******************************************************
	if( FALSE == fat_loadFatData() ){
		//return;
	}

	// wenn auf dem terminal "Boot...OK" zu lesen ist, war initialisierung erfolgreich!
			

	#if (MMC_WRITE ==TRUE)		// create and append only if write is TRUE
		
			//lcd_moveto_xy(7,20); printf("OK");		

		// ****************************************************
		// if file exists, it will be opened and then append to it.
		if( MMC_FILE_OPENED == ffopen(file_name,'r') ){			
			ffseek(file.length);
		   	ffwrites(str);				
			ffwrite(0x0D);		// new line in file
		   	ffwrite(0x0A);
			ffclose();
		}
		
		// ***************************************************
		// if the file does not exist, it will be created and written to it.
		if(MMC_FILE_CREATED == ffopen(file_name,'c') ){
			ffwrites(str);				
			ffwrite(0x0D);		// new line in file
		   	ffwrite(0x0A);
			ffclose();
			
		} 	
	#endif 

	// ***************************************************
	// read file complete and print via uart!
	if( MMC_FILE_OPENED == ffopen(file_name,'r') ){			
		seek = file.length;
		do{
		}while(--seek);
		ffclose();

		PORTB_OUTSET = PIN0_bm;  //fertig
	
	}
	
	
	while(1)
	{	

	
	}

	

		return (0);// retrun from main.c
}





// System Clocks initialization
void system_clocks_init(void)
{
unsigned char n,s;

// Save interrupts enabled/disabled state
s=SREG;
// Disable interrupts
cli();

// Internal 32/2 = 16MHz  RC oscillator intern
// Enable the internal 32 MHz RC oscillator
OSC.CTRL|=OSC_RC32MEN_bm;

// System Clock prescaler A division factor: 2
// System Clock prescalers B & C division factors: B:1, C:1
// ClkPer4: 16000,000 kHz
// ClkPer2: 16000,000 kHz
// ClkPer:  16000,000 kHz
// ClkCPU:  16000,000 kHz
n=(CLK.PSCTRL & (~(CLK_PSADIV_gm | CLK_PSBCDIV1_bm | CLK_PSBCDIV0_bm))) |
	CLK_PSADIV_2_gc | CLK_PSBCDIV_1_1_gc;
CCP=CCP_IOREG_gc;
CLK.PSCTRL=n;

// Disable the autocalibration of the internal 32 MHz RC oscillator
DFLLRC32M.CTRL&= ~DFLL_ENABLE_bm;

// Wait for the internal 32 MHz RC oscillator to stabilize
while ((OSC.STATUS & OSC_RC32MRDY_bm)==0);

// Select the system clock source: 32 MHz Internal RC Osc.
n=(CLK.CTRL & (~CLK_SCLKSEL_gm)) | CLK_SCLKSEL_RC32M_gc;
CCP=CCP_IOREG_gc;
CLK.CTRL=n;

// Disable the unused oscillators: 2 MHz, internal 32 kHz, external clock/crystal oscillator, PLL
OSC.CTRL&= ~(OSC_RC2MEN_bm | OSC_RC32KEN_bm | OSC_XOSCEN_bm | OSC_PLLEN_bm);

// Peripheral Clock output: Disabled
PORTCFG.CLKEVOUT=(PORTCFG.CLKEVOUT & (~PORTCFG_CLKOUT_gm)) | PORTCFG_CLKOUT_OFF_gc;

// Restore interrupts enabled/disabled state
SREG=s;


}


ISR(TCD0_OVF_vect ISR_BLOCK)	// 100ms fr Delay SD-Card
{


TimingDelay = (TimingDelay==0) ? 0 : TimingDelay-1;


}




